#ifndef FRAMEWORK_KERNEL_ERROR_MQH
#define FRAMEWORK_KERNEL_ERROR_MQH

#define ERROR_NO_ERROR -1
#define ERROR_NO_MQLERROR -2
#define ERROR_TRADE_TIMEOUT -3
#define ERROR_INVALID_PRICE -4
#define ERROR_INVALID_STOPS -5
#define ERROR_INVALID_TRADE_VOLUME -6
#define ERROR_MARKET_CLOSED -7
#define ERROR_TRADE_DISABLED -8
#define ERROR_NOT_ENOUGH_MONEY -9
#define ERROR_OFF_QUOTES -10
#define ERROR_BROKER_BUSY -11
#define ERROR_REQUOTE -12
#define ERROR_ORDER_LOCKED -13
#define ERROR_LONG_POSITIONS_ONLY_ALLOWED -14
#define ERROR_TOO_MANY_REQUESTS -15
#define ERROR_TRADE_MODIFY_DENIED -16
#define ERROR_TRADE_CONTEXT_BUSY -17
#define ERROR_TRADE_EXPIRATION_DENIED -18
#define ERROR_TRADE_TOO_MANY_ORDERS -19
#define ERROR_TRADE_HEDGE_PROHIBITED -21
#define ERROR_TRADE_PROHIBITED_BY_FIFO -22
#define ERROR_WRONG_FUNCTION_POINTER -23
#define ERROR_ARRAY_INDEX_OUT_OF_RANGE -24
#define ERROR_NO_MEMORY_FOR_CALL_STACK -25
#define ERROR_RECURSIVE_STACK_OVERFLOW -26
#define ERROR_NOT_ENOUGH_STACK_FOR_PARAM -27
#define ERROR_NO_MEMORY_FOR_PARAM_STRING -28
#define ERROR_NO_MEMORY_FOR_TEMP_STRING -29
#define ERROR_NOT_INITIALIZED_STRING -30
#define ERROR_NOT_INITIALIZED_ARRAYSTRING -31
#define ERROR_NO_MEMORY_FOR_ARRAYSTRING -32
#define ERROR_TOO_LONG_STRING -33
#define ERROR_REMAINDER_FROM_ZERO_DIVIDE -34
#define ERROR_ZERO_DIVIDE -35
#define ERROR_UNKNOWN_COMMAND -36
#define ERROR_WRONG_JUMP -37
#define ERROR_NOT_INITIALIZED_ARRAY -38
#define ERROR_DLL_CALLS_NOT_ALLOWED -39
#define ERROR_CANNOT_LOAD_LIBRARY -40
#define ERROR_CANNOT_CALL_FUNCTION -41
#define ERROR_EXTERNAL_CALLS_NOT_ALLOWED -42
#define ERROR_NO_MEMORY_FOR_RETURNED_STR -43
#define ERROR_SYSTEM_BUSY -44
#define ERROR_DLLFUNC_CRITICALERROR -45
#define ERROR_INTERNAL_ERROR -46
#define ERROR_OUT_OF_MEMORY -47
#define ERROR_INVALID_POINTER -48
#define ERROR_FORMAT_TOO_MANY_FORMATTERS -49
#define ERROR_FORMAT_TOO_MANY_PARAMETERS -50
#define ERROR_ARRAY_INVALID -51
#define ERROR_CHART_NOREPLY -52
#define ERROR_INVALID_FUNCTION_PARAMSCNT -53
#define ERROR_INVALID_FUNCTION_PARAMVALUE -54
#define ERROR_STRING_FUNCTION_INTERNAL -55
#define ERROR_SOME_ARRAY_ERROR -56
#define ERROR_INCORRECT_SERIESARRAY_USING -57
#define ERROR_CUSTOM_INDICATOR_ERROR -58
#define ERROR_INCOMPATIBLE_ARRAYS -59
#define ERROR_GLOBAL_VARIABLES_PROCESSING -60
#define ERROR_GLOBAL_VARIABLE_NOT_FOUND -61
#define ERROR_FUNC_NOT_ALLOWED_IN_TESTING -62
#define ERROR_FUNCTION_NOT_CONFIRMED -63
#define ERROR_SEND_MAIL_ERROR -64
#define ERROR_STRING_PARAMETER_EXPECTED -65
#define ERROR_INTEGER_PARAMETER_EXPECTED -66
#define ERROR_DOUBLE_PARAMETER_EXPECTED -67
#define ERROR_ARRAY_AS_PARAMETER_EXPECTED -68
#define ERROR_TRADE_ERROR -69
#define ERROR_RESOURCE_NOT_FOUND -70
#define ERROR_RESOURCE_NOT_SUPPORTED -71
#define ERROR_RESOURCE_DUPLICATED -72
#define ERROR_INDICATOR_CANNOT_INIT -73
#define ERROR_INDICATOR_CANNOT_LOAD -74
#define ERROR_NO_HISTORY_DATA -75
#define ERROR_NO_MEMORY_FOR_HISTORY -76
#define ERROR_END_OF_FILE -77
#define ERROR_SOME_FILE_ERROR -78
#define ERROR_WRONG_FILE_NAME -79
#define ERROR_TOO_MANY_OPENED_FILES -80
#define ERROR_CANNOT_OPEN_FILE -81
#define ERROR_INCOMPATIBLE_FILEACCESS -82
#define ERROR_NO_ORDER_SELECTED -83
#define ERROR_UNKNOWN_SYMBOL -84
#define ERROR_INVALID_PRICE_PARAM -85
#define ERROR_INVALID_TICKET -86
#define ERROR_TRADE_NOT_ALLOWED -87
#define ERROR_LONGS_NOT_ALLOWED -88
#define ERROR_SHORTS_NOT_ALLOWED -89
#define ERROR_TRADE_EXPERT_DISABLED_BY_SERVER -90
#define ERROR_OBJECT_ALREADY_EXISTS -91
#define ERROR_UNKNOWN_OBJECT_PROPERTY -92
#define ERROR_OBJECT_DOES_NOT_EXIST -93
#define ERROR_UNKNOWN_OBJECT_TYPE -94
#define ERROR_NO_OBJECT_NAME -95
#define ERROR_OBJECT_COORDINATES_ERROR -96
#define ERROR_NO_SPECIFIED_SUBWINDOW -97
#define ERROR_SOME_OBJECT_ERROR -98
#define ERROR_CHART_PROP_INVALID -99
#define ERROR_CHART_NOT_FOUND -100
#define ERROR_CHARTWINDOW_NOT_FOUND -101
#define ERROR_CHARTINDICATOR_NOT_FOUND -102
#define ERROR_SYMBOL_SELECT -103
#define ERROR_NOTIFICATION_ERROR -104
#define ERROR_NOTIFICATION_PARAMETER -105
#define ERROR_NOTIFICATION_SETTINGS -106
#define ERROR_NOTIFICATION_TOO_FREQUENT -107
#define ERROR_FILE_TOO_MANY_OPENED -108
#define ERROR_FILE_WRONG_FILENAME -109
#define ERROR_FILE_TOO_LONG_FILENAME -110
#define ERROR_FILE_CANNOT_OPEN -111
#define ERROR_FILE_BUFFER_ALLOCATION_ERROR -112
#define ERROR_FILE_CANNOT_DELETE -113
#define ERROR_FILE_INVALID_HANDLE -114
#define ERROR_FILE_WRONG_HANDLE -115
#define ERROR_FILE_NOT_TOREAD -116
#define ERROR_FILE_NOT_BIN -117
#define ERROR_FILE_NOT_TXT -118
#define ERROR_FILE_NOT_TXTORCSV -119
#define ERROR_FILE_NOT_CSV -120
#define ERROR_FILE_READ_ERROR -121
#define ERROR_FILE_WRITE_ERROR -122
#define ERROR_FILE_BIN_STRINGSIZE -123
#define ERROR_FILE_INCOMPATIBLE -124
#define ERROR_FILE_IS_DIRECTORY -125
#define ERROR_FILE_NOT_EXIST -126
#define ERROR_FILE_CANNOT_REWRITE -127
#define ERROR_FILE_WRONG_DIRECTORYNAME -128
#define ERROR_FILE_DIRECTORY_NOT_EXIST -129
#define ERROR_FILE_NOT_DIRECTORY -130
#define ERROR_FILE_CANNOT_DELETE_DIRECTORY -131
#define ERROR_FILE_CANNOT_CLEAN_DIRECTORY -132
#define ERROR_FILE_STRINGRESIZE_ERROR -133
#define ERROR_FILE_STRUCT_WITH_OBJECTS -134
#define ERROR_WEBREQUEST_INVALID_ADDRESS -135
#define ERROR_WEBREQUEST_CONNECT_FAILED -136
#define ERROR_WEBREQUEST_TIMEOUT -137
#define ERROR_WEBREQUEST_REQUEST_FAILED -138
#define ERROR_HISTORY_WILL_UPDATED -139
#define ERROR_FILE_NOT_TOWRITE -140

#endif